<?php
/****************************************************************************
-----------------------------------------------------------------------------
 *  File            :     IndexController.php
 *  Subpackage      :     MofluidWS
 *  Packahe         :     Mofluid
 *  Description     :     MofluidWS is plugin for magento to communicate with mofluid Application
 *  File URL        :     YourSiteURL/MofluidWS 
 *  Developer       :     Shashi Badhuk
 *  Team Lead       :     Shashank Singh
 *  Project Manager :     Utkarsh Srivastava
 *  CEO             :     Sudeep Goyal
 *  Organization    :     Ebizon Net Info Pvt Ltd 
 *  Org URL         :     http://www.ebizontek.com
-----------------------------------------------------------------------------
 *****************************************************************************/
include_once('Service.php');
class Mofluid_MofluidWS_IndexController extends Mage_Core_Controller_Front_Action {

    /*==============      Invoke First When Web Service Access     ================*/
    public function indexAction() {

           try {
 
               $store = -1;
               $store = $_GET["store"];
               $service = $_GET["service"];
               $categoryid = $_GET["categoryid"];
               $firstname = $_GET["firstname"];
               $lastname = $_GET["lastname"];
               $email = $_GET["email"];
               $password = $_GET["password"];
               $oldpassword = $_GET["oldpassword"];
               $newpassword = $_GET["newpassword"];
               $productid = $_GET["productid"];
               $custid = $_GET["customerid"];
               $billAdd = $_GET["billaddress"];
               $shippAdd = $_GET["shippaddress"];
               $pmethod = $_GET["paymentmethod"];
               $transid = $_GET["transactionid"];
               $product = $_GET["product"];
               $shippCharge = $_GET["shippcharge"];
               $search_data = $_GET["search_data"];
               $username = $_GET["username"];
               $ws_service = new Service();
                  if($store == -1 || $store == null || $store == "" )
                        $this->ws_store404($store);
                  else {
                       if($service == "category") {
                           $res = $ws_service->ws_category($store, $service);
                           echo $_GET["callback"].'('.json_encode($res).');';
					   }
                       elseif($service == "subcategory") {
						   $res = $ws_service->ws_subcategory($store, $service, $categoryid);
                           echo $_GET["callback"].'('.json_encode($res).');';
					   }
                       elseif($service == "products") {
                           $res = $ws_service->ws_products($store, $service, $categoryid);
                           echo $_GET["callback"].'('.json_encode($res).');';
                       } 
		               elseif($service == "createuser") {
                           $res = $ws_service->ws_createuser($store, $service, $firstname, $lastname, $email, $password);
                           echo $_GET["callback"].'('.json_encode($res).');';
					   }
					   elseif($service == "productdetail") {
                           $res = $ws_service->ws_productdetail($store, $service, $productid);
                           echo $_GET["callback"].'('.json_encode($res).');';
					   }
					   elseif($service == "currency") {
                           $res = $ws_service->ws_currency($store, $service);
                           echo $_GET["callback"].'('.json_encode($res).');';
					   }
					   elseif($service == "createorder") {
                           $res = $ws_service->ws_createorder($store, $service, $custid, $pmethod, $transid, $product, $shippCharge);
                           echo $_GET["callback"].'('.json_encode($res).');';
					   }
					   elseif($service == "setaddress") {
						   //var_dump($billAdd); die;
                           $res = $ws_service->ws_setaddress($store, $service, $custid, $billAdd, $shippAdd);
                           echo $_GET["callback"].'('.json_encode($res).');';
					   }
					   elseif($service == "storedetails") {
						   $res = $ws_service->ws_storedetails($store, $service);
                                                   echo $_GET["callback"].'('.json_encode($res).');';    
					   }
                                           elseif($service == "search") {
                                                   $res = $ws_service->ws_search($store, $service,$search_data);
                                                   echo $_GET["callback"].'('.json_encode($res).');';
                                           }
                                           elseif($service == "getcustomer") {
                                                   $res = $ws_service->ws_getCustomerId($store, $service, $email);
                                                   echo $_GET["callback"].'('.json_encode($res).');';
                                           }
                                           elseif($service == "verifylogin") {
                                                   $res = $ws_service->ws_verifyLogin($store, $service, $username, $password);
                                                   echo $_GET["callback"].'('.json_encode($res).');';
                                           }
                                           elseif($service == "myorders") {
                                                   $res = $ws_service->ws_myOrder($custid);
                                                   echo $_GET["callback"].'('.json_encode($res).');';
                                           }
                                           elseif($service == "myprofile") {
                                                   $res = $ws_service->ws_myProfile($custid);
                                                   echo $_GET["callback"].'('.json_encode($res).');';
                                           }
                                           elseif($service == "changeprofilepassword") {
                                                   $res = $ws_service->ws_changeProfilePassword($custid, $username, $oldpassword, $newpassword, $store);
                                                   echo $_GET["callback"].'('.json_encode($res).');';
                                           }
                                           elseif($service == "productsearchhelp") {
                                                   $res = $ws_service->ws_productSearchHelp($store);
                                                   echo $_GET["callback"].'('.json_encode($res).');';
                                           } 
                                           else
                                                   $this->ws_service404($service);
                                           }
            }
            catch(Exception $exc) {
                echo 'Exception : '.$exc;
            }
    }

   /*=====================      Handle When Store Not Found      =========================*/
    public function ws_store404($store) {
          echo 'Store 404 Error :  Store '.$store.' is not found on your host ';
    }
   /*=====================      Handle When Service Not Found      =========================*/
    public function ws_service404($service){
         if($service == "" || $service == null)
             echo 'Service 404 Error :  No Web Service found under Mofluid-Magento Plugin by Mofluid Team at your domain';
         else
             echo 'Service 404 Error : '.$service.' Web Service is not controlled under Mofluid Magento Plugin by Mofluid Team at your domain';
    }
}
